
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int score_computer = 0 ;
int score_human    = 0 ;

int said_yes ()
{
  int c ;

  do
  {
    c = getchar () ;
  } while ( c != 'y' && c != 'Y' && c != 'n' && c != 'N' ) ;

  while ( getchar () != '\n' )
    /* Discard the rest of the line */ ;

  return ( c == 'y' || c == 'Y' ) ;
}


char *getstring ()
{
  char name [ 1024 ] ;
  char *p = name ;
  int i ;

  for ( i = 0 ; i < 1023 ; i++ )
  {
    name [ i ] = getchar () ;

    if ( name [ i ] == '\n' )
      break ;
  }

  name [ i ] = '\0' ;

  while ( *p <= ' ' && *p != '\0' )
    p++ ;

  if ( *p == '\0' )
    return NULL ;

  char *res = new char [ strlen ( p ) + 1 ] ;
  strcpy ( res, p ) ;
  return res ;
}


int isVowel ( char c )
{
  return ( c == 'a' || c == 'A' || c == 'e' || c == 'E' ||
           c == 'i' || c == 'I' || c == 'o' || c == 'O' ||
           c == 'u' || c == 'U' ) ;
}


const char *a_or_an ( char c )
{
  return isVowel ( c ) ? "an" : "a" ;
}



class Qnode
{
  char *question ;
  char *animal ;
  Qnode *yes ;
  Qnode *no  ;

public:

  Qnode ( char *guess ) { question = NULL ; animal = guess ; yes = no = NULL ; }
 ~Qnode () { delete question ; delete animal ; delete yes ; delete no ; }
  void ask () ;
  void add () ;

  void dump ( FILE *fd = NULL ) ;
  void load ( FILE *fd = NULL ) ;
} ;


void Qnode::load ( FILE *fd )
{
  int top = ( fd == NULL ) ;

  if ( top )
  {
    fd = fopen ( "animals.dat", "r" ) ;

    if ( fd == NULL )
    {
      fd = fopen ( "animals.dat", "w" ) ;

      if ( fd != NULL )
      {
        fprintf ( fd, "Q:Is it furry\nA:Cow\nA:Goldfish\n" ) ;
        fclose ( fd ) ;
        fd = fopen ( "animals.dat", "r" ) ;
      }
    }

    if ( fd == NULL )
    {
      fprintf ( stderr, "guess_animals: Can't open animals.dat.\n" ) ;
      exit ( 1 ) ;
    }
  }

  char buffer [ 1024 ] ;

  fgets ( buffer, 1023, fd ) ;

  buffer [ strlen ( buffer ) - 1 ] = '\0' ;

  if ( buffer [ 0 ] == 'Q' )
  {
    question = new char [ strlen ( & buffer[2] ) + 1 ] ;
    strcpy ( question, & buffer [ 2 ] ) ;

    yes = new Qnode ( NULL ) ; yes -> load ( fd ) ;
    no  = new Qnode ( NULL ) ; no  -> load ( fd ) ;
  }
  else
  {
    animal = new char [ strlen ( & buffer[2] ) + 1 ] ;
    strcpy ( animal, & buffer [ 2 ] ) ;
  }

  if ( top )
    fclose ( fd ) ;
}


void Qnode::dump ( FILE *fd )
{
  int top = ( fd == NULL ) ;

  if ( top )
    fd = fopen ( "animals.dat", "w" ) ;

  if ( question != NULL )
  {
    fprintf ( fd, "Q:%s\n", question ) ;
    yes -> dump ( fd ) ;
    no -> dump ( fd ) ;
  }
  else
    fprintf ( fd, "A:%s\n", animal ) ;

  if ( top )
    fclose ( fd ) ;
}


void Qnode::ask ()
{
  printf ( "\n" ) ;

  if ( question )
    printf ( "%s?\n", question ) ;
  else
    printf ( "Is it %s %s?\n", a_or_an(animal[0]), animal ) ;

  printf ( "Type 'y' or 'n' and hit Enter: " ) ;

  if ( said_yes () )
  {
    if ( animal )
    {
      score_computer++ ;
      printf ( "Hooray! I got it right!  It was %s %s!\n",
                                     a_or_an(animal[0]), animal ) ;
      printf ( "\n" ) ;
      printf ( "The score is now %d to me and %d to you.\n",
              score_computer, score_human ) ;
      printf ( "\n" ) ;
    }
    else
      yes -> ask () ;
  }
  else
  {
    if ( animal )
      add () ;
    else
      no -> ask () ;
  }
}


void Qnode::add ()
{
  score_human++ ;
  printf ( "\n" ) ;
  printf ( "OK, you fooled me. It wasn't %s %s.\n",
                                     a_or_an ( animal[0] ), animal ) ;
  char *name ;

  do
  {
    printf ( "\n" ) ;
    printf ( "What was it?\n" ) ;
    printf ( "Type in the name of the animal then press Enter: " ) ;
  } while ( (name = getstring ()) == NULL ) ;

  do
  {
    printf ( "\n" ) ;
    printf ( "Well, perhaps you can suggest what I should ask next\n" ) ;
    printf ( "time I need to tell the difference between %s %s\n",
                                     a_or_an ( animal[0] ), animal ) ;
    printf ( "and %s %s.\n",         a_or_an (   name[0] ), name ) ;
    printf ( "Please type in a question and then hit Enter,\n" ) ;
    printf ( "Question: " ) ; 
  } while ( (question = getstring ()) == NULL ) ;


  printf ( "\n" ) ;
  printf ( "Oh - I see.  So, if you were thinking of %s %s and\n",
                                     a_or_an ( name[0] ), name ) ;
  printf ( "I said \"%s?\",\n", question ) ;
  printf ( "would you answer yes or no?\n", question ) ;

  printf ( "Type 'y' or 'n' and hit Enter: " ) ;

  if ( said_yes () )
  {
    yes = new Qnode ( name   ) ;
    no  = new Qnode ( animal ) ;
  }
  else
  {
    yes = new Qnode ( animal ) ;
    no  = new Qnode ( name   ) ;
  }

  animal = NULL ;

  printf ( "\n" ) ;
  printf ( "The score is now %d to me and %d to you.\n",
             score_computer, score_human ) ;
  printf ( "\n" ) ;
}


int main ()
{
  Qnode *q = new Qnode ( NULL ) ;

  q -> load () ;

  printf ( "\n\n" ) ;
  printf ( "Hello!\n" ) ;
  printf ( "\n" ) ;
  printf ( "Welcome to the game of Guess Animals!\n" ) ;
  printf ( "\n" ) ;

  while ( 1 )
  {
    printf ( "\n\n" ) ;
    printf ( "OK, you think of an animal - and I'll\n" ) ;
    printf ( "try to guess what it is.\n" ) ;
    printf ( "\n" ) ;
    printf ( "Have you thought of an animal?\n" ) ;
    printf ( "Type 'y' or 'n' and hit Enter: " ) ;

    if ( said_yes () )
    {
      q -> ask  () ;
      q -> dump () ;
    }
    else
    {
      printf ( "\n" ) ;
      printf ( "OK - bye bye then.\n" ) ;
      printf ( "\n" ) ;

      if ( score_computer == score_human )
        printf ( "It was a DRAW!!\n" ) ;
      else
      if ( score_computer > score_human )
        printf ( "I win! Computers are SO much smarter than people!\n" ) ;
      else
      {
        printf ( "You won. I really didn't feel like playing.\n" ) ;
        printf ( "It's a silly game anyway.\n" ) ;
        printf ( "AND you probably cheated.\n" ) ;
      }
      printf ( "\n" ) ;
      printf ( "The final score was %d to me and %d to you.\n",
                                 score_computer, score_human ) ;
      printf ( "\n" ) ;
      exit ( 0 ) ;
    }
  }
}

